<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_rating_survey".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderRatingSurvey".
 *
 * Columns in table "provider_rating_survey" available as properties of the model,
 * followed by relations of table "provider_rating_survey" available as properties of the model.
 *
 * @property integer $id
 * @property integer $localization_id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property integer $organization_id
 * @property integer $listing_partner_site_id
 * @property string $listing_distribution
 * @property integer $rating
 * @property string $title
 * @property string $description
 * @property integer $rating_getting_appt
 * @property integer $rating_appearance
 * @property integer $rating_courtesy
 * @property integer $rating_waiting_time
 * @property integer $rating_friendliness
 * @property integer $rating_spending_time
 * @property integer $rating_diagnosis
 * @property integer $rating_follow_up
 * @property integer $rating_billing
 * @property integer $rating_listening_skills
 * @property integer $rating_clear_explanations
 * @property integer $rating_trust
 * @property string $review_id
 * @property string $pg_survey_id
 * @property string $pg_client_id
 * @property string $pg_survey_date_added
 * @property string $pg_survey_date_updated
 * @property string $status
 * @property string $pg_survey_date_deleted
 * @property string $date_added
 * @property string $date_updated
 * @property string $friendly_url
 *
 * @property Provider $provider
 * @property Practice $practice
 * @property PartnerSite $listingPartnerSite
 * @property Organization $organization
 * @property Localization $localization
 */
abstract class BaseProviderRatingSurvey extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_rating_survey';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderRatingSurvey|ProviderRatingSurveys', $n);
    }

    public static function representingColumn()
    {
        return 'title';
    }

    public function rules()
    {
        return array(
            array('provider_id, practice_id, organization_id, rating, title, description, review_id, pg_survey_id, pg_client_id, pg_survey_date_added, pg_survey_date_updated, date_added, date_updated', 'required'),
            array('localization_id, provider_id, practice_id, organization_id, listing_partner_site_id, rating, rating_getting_appt, rating_appearance, rating_courtesy, rating_waiting_time, rating_friendliness, rating_spending_time, rating_diagnosis, rating_follow_up, rating_billing, rating_listening_skills, rating_clear_explanations, rating_trust', 'numerical', 'integerOnly'=>true),
            array('listing_distribution', 'length', 'max'=>9),
            array('title, review_id, pg_survey_id, pg_client_id, friendly_url', 'length', 'max'=>255),
            array('status', 'length', 'max'=>1),
            array('pg_survey_date_deleted', 'safe'),
            array('localization_id, listing_partner_site_id, rating_getting_appt, rating_appearance, rating_courtesy, rating_waiting_time, rating_friendliness, rating_spending_time, rating_diagnosis, rating_follow_up, rating_billing, rating_listening_skills, rating_clear_explanations, rating_trust, status, pg_survey_date_deleted, friendly_url', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, localization_id, provider_id, practice_id, organization_id, listing_partner_site_id, listing_distribution, rating, title, description, rating_getting_appt, rating_appearance, rating_courtesy, rating_waiting_time, rating_friendliness, rating_spending_time, rating_diagnosis, rating_follow_up, rating_billing, rating_listening_skills, rating_clear_explanations, rating_trust, review_id, pg_survey_id, pg_client_id, pg_survey_date_added, pg_survey_date_updated, status, pg_survey_date_deleted, date_added, date_updated, friendly_url', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'listingPartnerSite' => array(self::BELONGS_TO, 'PartnerSite', 'listing_partner_site_id'),
            'organization' => array(self::BELONGS_TO, 'Organization', 'organization_id'),
            'localization' => array(self::BELONGS_TO, 'Localization', 'localization_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'localization_id' => null,
            'provider_id' => null,
            'practice_id' => null,
            'organization_id' => null,
            'listing_partner_site_id' => null,
            'listing_distribution' => Yii::t('app', 'Listing Distribution'),
            'rating' => Yii::t('app', 'Rating'),
            'title' => Yii::t('app', 'Title'),
            'description' => Yii::t('app', 'Description'),
            'rating_getting_appt' => Yii::t('app', 'Rating Getting Appt'),
            'rating_appearance' => Yii::t('app', 'Rating Appearance'),
            'rating_courtesy' => Yii::t('app', 'Rating Courtesy'),
            'rating_waiting_time' => Yii::t('app', 'Rating Waiting Time'),
            'rating_friendliness' => Yii::t('app', 'Rating Friendliness'),
            'rating_spending_time' => Yii::t('app', 'Rating Spending Time'),
            'rating_diagnosis' => Yii::t('app', 'Rating Diagnosis'),
            'rating_follow_up' => Yii::t('app', 'Rating Follow Up'),
            'rating_billing' => Yii::t('app', 'Rating Billing'),
            'rating_listening_skills' => Yii::t('app', 'Rating Listening Skills'),
            'rating_clear_explanations' => Yii::t('app', 'Rating Clear Explanations'),
            'rating_trust' => Yii::t('app', 'Rating Trust'),
            'review_id' => Yii::t('app', 'Review'),
            'pg_survey_id' => Yii::t('app', 'Pg Survey'),
            'pg_client_id' => Yii::t('app', 'Pg Client'),
            'pg_survey_date_added' => Yii::t('app', 'Pg Survey Date Added'),
            'pg_survey_date_updated' => Yii::t('app', 'Pg Survey Date Updated'),
            'status' => Yii::t('app', 'Status'),
            'pg_survey_date_deleted' => Yii::t('app', 'Pg Survey Date Deleted'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'friendly_url' => Yii::t('app', 'Friendly Url'),
            'provider' => null,
            'practice' => null,
            'listingPartnerSite' => null,
            'organization' => null,
            'localization' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('localization_id', $this->localization_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('organization_id', $this->organization_id);
        $criteria->compare('listing_partner_site_id', $this->listing_partner_site_id);
        $criteria->compare('listing_distribution', $this->listing_distribution, true);
        $criteria->compare('rating', $this->rating);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('rating_getting_appt', $this->rating_getting_appt);
        $criteria->compare('rating_appearance', $this->rating_appearance);
        $criteria->compare('rating_courtesy', $this->rating_courtesy);
        $criteria->compare('rating_waiting_time', $this->rating_waiting_time);
        $criteria->compare('rating_friendliness', $this->rating_friendliness);
        $criteria->compare('rating_spending_time', $this->rating_spending_time);
        $criteria->compare('rating_diagnosis', $this->rating_diagnosis);
        $criteria->compare('rating_follow_up', $this->rating_follow_up);
        $criteria->compare('rating_billing', $this->rating_billing);
        $criteria->compare('rating_listening_skills', $this->rating_listening_skills);
        $criteria->compare('rating_clear_explanations', $this->rating_clear_explanations);
        $criteria->compare('rating_trust', $this->rating_trust);
        $criteria->compare('review_id', $this->review_id, true);
        $criteria->compare('pg_survey_id', $this->pg_survey_id, true);
        $criteria->compare('pg_client_id', $this->pg_client_id, true);
        $criteria->compare('pg_survey_date_added', $this->pg_survey_date_added, true);
        $criteria->compare('pg_survey_date_updated', $this->pg_survey_date_updated, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('pg_survey_date_deleted', $this->pg_survey_date_deleted, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('friendly_url', $this->friendly_url, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
